<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:tibet="http://www.technicalpursuit.com/1999/tibet"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    version="1.0">

    <xsl:output method="xml" indent="yes" />

    <!-- The 'identity transformation', which copies all nodes and attributes
            to the output -->
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="/CssModule">
        <xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema">
            <xsl:apply-templates />
        </xsd:schema>
    </xsl:template>

    <xsl:template match="CssProperty">
        <xsd:element>
            <xsl:attribute name="name">
                <xsl:value-of select="@name"/>
            </xsl:attribute>
            <xsl:attribute name="type">
                <xsl:text>xs:string</xsl:text>
            </xsl:attribute>
            <xsd:annotation>
                <xsd:documentation>
                    <xsl:value-of select="@description"/>
                </xsd:documentation>
            </xsd:annotation>
        </xsd:element>
    </xsl:template>

</xsl:stylesheet>
