//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.ScraperService}
 * @summary Common supertype for other TP.test objects like TP.test.Case and
 *     TP.test.Suite.
 */

TP.lang.Object.defineSubtype('core.ScraperService');

TP.core.ScraperService.addTraits(TP.core.PromiseProvider);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.ScraperService.Inst.defineAttribute('driver');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.ScraperService.Inst.defineMethod('init',
function(options) {

    var driver,
        scraperObject,
        scraperTPWin;

    driver = TP.test.GUIDriver.construct();

    driver.set('promiseProvider', this);

    scraperObject = TP.documentConstructIFrameElement(TP.sys.uidoc(true));

    scraperTPWin = TP.wrap(scraperObject.contentWindow);
    driver.set('windowContext', scraperTPWin);

    this.set('driver', driver);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.ScraperService.Inst.defineMethod('doIt',
function(options) {

    var driver;

    driver = this.get('driver');

    driver.setLocation(TP.uc('http://www.google.com'),
                        null,
                        TP.request('processContent', false));

    this.chain(
        function(evt) {
            var signal,
                docTPElem;

            signal = TP.wrap(evt);

            docTPElem = TP.wrap(signal.getResolvedTarget()).
                                        getContentDocument().
                                        getDocumentElement();

            console.log(docTPElem.get(TP.cpc('.ctr-p')));
        });
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
