TP.uc('~lib_dat/TP.core.USAscii101Keyboard.xml').setContent(
'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>\n\n<keyboard name="USAscii101Keyboard">\n\n  <!--\n  Keyboard definition for a typical US Ascii 101 Keyboard.\n\n  ID values are prefixed with an underscore (\'_\') to avoid issues with XML.\n  A leading underscore simply makes a numeric code into a valid ID. When a\n  map entry is for a keycode in combination with the Shift key a suffix of\n  \'_shifted\' is appended.\n\n  NOTE that keyboard maps of this type rely on logic in the matching\n  TP.core.Keyboard subtype to normalize keycode/charcode values for browser\n  and platform differences, at least to the extent that a unique ID can be\n  used to provide a mapping. TIBET \'normalizes\' the keycode to whatever the\n  \'keydown\' event uses (\'keypress\' events often get their keyCode wrong).\n\n  TIBET signal names are computed from this map using the following algorithm:\n\n  1.  The name starts with the String \'DOM_\'\n  2.  If any of the modifier keys (Meta, Ctrl, Alt or Shift) are pressed,\n      that word is added to the name (i.e. \'Ctrl_\'). There is an order by\n      which multiple modifiers can be specified:\n\n        a.  \'Meta\'\n        b.  \'Ctrl\'\n        c.  \'Alt\'\n        d.  \'Shift\'\n\n      So a signal name could be: \'DOM_Ctrl_Shift_Tab_Down\', but *not*\n      \'DOM_Shift_Ctrl_Tab_Down\'\n\n  3.  If the key has a value for the \'key=\' attribute in this map, that\n      value is used:\n\n        DOM_Ctrl_Percent_Up\n        DOM_Ctrl_A_Up           //  NB: Lowercase \'a\'\n        DOM_Ctrl_Shift_A_Up     //  NB: Uppercase \'A\'\n\n  4.  If the key does not have a value for the \'key=\' attribute in this\n      map, the value in the \'glyph=\' attribute is used:\n\n        DOM_1_Up\n\n  5.  In addition to either the \'key\' or \'glyph\' value being used in a\n      signal name, TIBET will also generate a second signal name using the\n      Unicode value stored in the \'char=\' attribute. This allows\n      difficult-to-encode keys to be observed:\n\n        DOM_U0027_Up            //  NB: Same as \'DOM_Right_Up\'\n\n  If a key code is representing more than one entry, that means it will have\n  qualifiers depending on operating system (the \'platform\' attribute) and the\n  browser (the \'browser\' attribute). These entries are sorted in the following\n  order:\n\n    - no qualifier\n    - \'platform\' qualifier\n    - \'browser\' qualifier\n    - \'browser\' AND \'platform\' qualifier\n\n  The entry that is found last is then used to dispatch the key.\n\n  This keymap, tested on 5-APR-2013, was tested on the following browsers and\n  operating systems:\n\n    - IE8\n    - Firefox 20.0 (Mac and Windows)\n    - Chrome 26.0 (Mac and Windows)\n    - Safari 6.0 (Mac)\n  -->\n\n  <!-- ** <key keycode="_3" char="U0018" key="Cancel"/> -->\n  <!-- ** <key keycode="_6" key="Help"/> -->\n  <key keycode="_8" char="U0008" key="Backspace"/>\n  <key keycode="_9" char="U0009" key="Tab"/>\n\n  <!-- ** <key keycode="_10" key="Enter"/> -->\n  <key keycode="_12" platform="macosx" key="Clear"/>\n  <key keycode="_13" key="Enter"/>\n\n  <key keycode="_16" key="Shift"/>\n  <!-- Note that, even though we follow the W3C name of \'Control\' here, TIBET\n       will rename this key to \'Ctrl\' for consistency with key names that are\n       generated with the \'Ctrl\' modifier. -->\n  <key keycode="_17" key="Control"/>\n  <key keycode="_18" key="Alt"/>\n  <key keycode="_19" platform="win" key="Pause"/>\n  <key keycode="_20" key="CapsLock"/>\n\n  <key keycode="_27" char="U001B" key="Esc"/>\n\n  <key keycode="_32" key="Spacebar"/>\n\n  <key keycode="_33" key="PageUp"/>\n  <!-- ** <key keycode="_33_shifted" key="Excl"/> -->\n  <key keycode="_34" key="PageDown"/>\n  <!-- ** <key keycode="_34_shifted" key="???"/> -->\n  <key keycode="_35" key="End"/>\n  <!-- ** <key keycode="_35_shifted" key="Num"/> -->\n  <key keycode="_36" key="Home"/>\n  <!-- ** <key keycode="_36_shifted" key="Dollar"/> -->\n\n  <!-- Arrow keys -->\n  <key keycode="_37" key="Left"/>\n  <key keycode="_38" key="Up"/>\n  <key keycode="_39" key="Right"/>\n  <key keycode="_40" key="Down"/>\n\n  <!-- NOTE!!: This only reports this keycode on key up! -->\n  <key keycode="_44" platform="win" key="PrintScreen"/>\n\n  <key keycode="_45" platform="win" key="Insert"/>\n  <!-- Forward delete -->\n  <key keycode="_46" key="Del"/>\n\n  <!-- Alphabetic / Shift-ed Alphabetic -->\n\n  <key keycode="_65" char="U0061" glyph="a"/>\n  <key keycode="_65_shifted" char="U0041" glyph="A"/>\n\n  <key keycode="_66" char="U0062" glyph="b"/>\n  <key keycode="_66_shifted" char="U0042" glyph="B"/>\n\n  <key keycode="_67" char="U0063" glyph="c"/>\n  <key keycode="_67_shifted" char="U0043" glyph="C"/>\n\n  <key keycode="_68" char="U0064" glyph="d"/>\n  <key keycode="_68_shifted" char="U0044" glyph="D"/>\n\n  <key keycode="_69" char="U0065" glyph="e"/>\n  <key keycode="_69_shifted" char="U0045" glyph="E"/>\n\n  <key keycode="_70" char="U0066" glyph="f"/>\n  <key keycode="_70_shifted" char="U0046" glyph="F"/>\n\n  <key keycode="_71" char="U0067" glyph="g"/>\n  <key keycode="_71_shifted" char="U0047" glyph="G"/>\n\n  <key keycode="_72" char="U0068" glyph="h"/>\n  <key keycode="_72_shifted" char="U0048" glyph="H"/>\n\n  <key keycode="_73" char="U0069" glyph="i"/>\n  <key keycode="_73_shifted" char="U0049" glyph="I"/>\n\n  <key keycode="_74" char="U006A" glyph="j"/>\n  <key keycode="_74_shifted" char="U004A" glyph="J"/>\n\n  <key keycode="_75" char="U006B" glyph="k"/>\n  <key keycode="_75_shifted" char="U004B" glyph="K"/>\n\n  <key keycode="_76" char="U006C" glyph="l"/>\n  <key keycode="_76_shifted" char="U004C" glyph="L"/>\n\n  <key keycode="_77" char="U006D" glyph="m"/>\n  <key keycode="_77_shifted" char="U004D" glyph="M"/>\n\n  <key keycode="_78" char="U006E" glyph="n"/>\n  <key keycode="_78_shifted" char="U004E" glyph="N"/>\n\n  <key keycode="_79" char="U006F" glyph="o"/>\n  <key keycode="_79_shifted" char="U004F" glyph="O"/>\n\n  <key keycode="_80" char="U0070" glyph="p"/>\n  <key keycode="_80_shifted" char="U0050" glyph="P"/>\n\n  <key keycode="_81" char="U0071" glyph="q"/>\n  <key keycode="_81_shifted" char="U0051" glyph="Q"/>\n\n  <key keycode="_82" char="U0072" glyph="r"/>\n  <key keycode="_82_shifted" char="U0052" glyph="R"/>\n\n  <key keycode="_83" char="U0073" glyph="s"/>\n  <key keycode="_83_shifted" char="U0053" glyph="S"/>\n\n  <key keycode="_84" char="U0074" glyph="t"/>\n  <key keycode="_84_shifted" char="U0054" glyph="T"/>\n\n  <key keycode="_85" char="U0075" glyph="u"/>\n  <key keycode="_85_shifted" char="U0055" glyph="U"/>\n\n  <key keycode="_86" char="U0076" glyph="v"/>\n  <key keycode="_86_shifted" char="U0056" glyph="V"/>\n\n  <key keycode="_87" char="U0077" glyph="w"/>\n  <key keycode="_87_shifted" char="U0057" glyph="W"/>\n\n  <key keycode="_88" char="U0078" glyph="x"/>\n  <key keycode="_88_shifted" char="U0058" glyph="X"/>\n\n  <key keycode="_89" char="U0079" glyph="y"/>\n  <key keycode="_89_shifted" char="U0059" glyph="Y"/>\n\n  <key keycode="_90" char="U007A" glyph="z"/>\n  <key keycode="_90_shifted" char="U005A" glyph="Z"/>\n\n  <!-- Numeric / Shift-ed Numeric -->\n\n  <key keycode="_48" char="U0030" glyph="0"/>\n  <key keycode="_48_shifted" char="U0029" key="RightParen" glyph=")"/>\n\n  <key keycode="_49" char="U0031" glyph="1"/>\n  <key keycode="_49_shifted" char="U0021" key="Exclamation" glyph="!"/>\n\n  <key keycode="_50" char="U0032" glyph="2"/>\n  <key keycode="_50_shifted" char="U0040" key="At" glyph="@"/>\n\n  <key keycode="_51" char="U0033" glyph="3"/>\n  <key keycode="_51_shifted" char="U0023" key="Hash" glyph="#"/>\n\n  <key keycode="_52" char="U0034" glyph="4"/>\n  <key keycode="_52_shifted" char="U0024" key="Dollar" glyph="$"/>\n\n  <key keycode="_53" char="U0035" glyph="5"/>\n  <key keycode="_53_shifted" char="U0025" key="Percent" glyph="%"/>\n\n  <key keycode="_54" char="U0036" glyph="6"/>\n  <key keycode="_54_shifted" char="U005E" key="Circumflex" glyph="^"/>\n\n  <key keycode="_55" char="U0037" glyph="7"/>\n  <key keycode="_55_shifted" char="U0026" key="Ampersand" glyph="&amp;"/>\n\n  <key keycode="_56" char="U0038" glyph="8"/>\n  <key keycode="_56_shifted" char="U002A" key="Asterisk" glyph="*"/>\n\n  <key keycode="_57" char="U0039" glyph="9"/>\n  <key keycode="_57_shifted" char="U0028" key="LeftParen" glyph="("/>\n\n  <!-- The \'Equals\' character -->\n  <key keycode="_187" char="U003D" key="Equals" glyph="="/>\n  <key keycode="_61" browser="firefox" char="U003D" key="Equals" glyph="="/>\n\n  <!-- The \'Plus\' character -->\n  <key keycode="_187_shifted" char="U002B" key="Plus" glyph="+"/>\n  <key keycode="_61_shifted" browser="firefox" char="U002B" key="Plus" glyph="+"/>\n\n  <!-- The \'HyphenMinus\' character -->\n  <key keycode="_189" char="U002D" key="HyphenMinus" glyph="-"/>\n  <key keycode="_173" browser="firefox" char="U002D" key="HyphenMinus" glyph="-"/>\n\n  <!-- The \'Underscore\' character -->\n  <key keycode="_189_shifted" char="U005F" key="Underscore" glyph="_"/>\n  <key keycode="_173_shifted" browser="firefox" char="U005F" key="Underscore" glyph="_"/>\n\n  <key keycode="_192" char="U0060" key="Grave" glyph="`"/>\n  <key keycode="_192_shifted" char="U007E" key="Tilde" glyph="~"/> <!-- \'Tilde\' not a DOM L3 name -->\n\n  <!-- Numeric keypad (when in numeric mode) -->\n\n  <key keycode="_96" char="U0030" glyph="0"/>\n  <key keycode="_97" char="U0031" glyph="1"/>\n  <key keycode="_98" char="U0032" glyph="2"/>\n  <key keycode="_99" char="U0033" glyph="3"/>\n  <key keycode="_100" char="U0034" glyph="4"/>\n  <key keycode="_101" char="U0035" glyph="5"/>\n  <key keycode="_102" char="U0036" glyph="6"/>\n  <key keycode="_103" char="U0037" glyph="7"/>\n  <key keycode="_104" char="U0038" glyph="8"/>\n  <key keycode="_105" char="U0039" glyph="9"/>\n\n  <!-- Numeric keypad -->\n\n  <key keycode="_106" key="Multiply" glyph="*"/>\n\n  <!-- The \'Add\' key -->\n  <key keycode="_107" key="Add" glyph="+"/>\n  <key keycode="_187" platform="macosx" browser="safari" key="Add" glyph="+"/>\n\n  <!-- ** <key keycode="_108" key="Separator"/> -->\n\n  <!-- The \'Subtract\' key -->\n  <key keycode="_109" key="Subtract" glyph="-"/>\n  <key keycode="_189" platform="macosx" browser="safari" key="Subtract" glyph="-"/>\n\n  <!-- The \'Decimal\' key -->\n  <key keycode="_110" key="Decimal" glyph="."/>\n  <key keycode="_190" platform="macosx" browser="safari" key="Decimal" glyph="."/>\n\n  <!-- The \'Divide\' key -->\n  <key keycode="_111" key="Divide" glyph="/"/>\n  <key keycode="_191" platform="macosx" browser="safari" key="Divide" glyph="/"/>\n\n  <!-- Function keys -->\n\n  <key keycode="_112" key="F1"/>\n  <key keycode="_113" key="F2"/>\n  <key keycode="_114" key="F3"/>\n  <key keycode="_115" key="F4"/>\n  <key keycode="_116" key="F5"/>\n  <key keycode="_117" key="F6"/>\n  <key keycode="_118" key="F7"/>\n  <key keycode="_119" key="F8"/>\n  <key keycode="_120" key="F9"/>\n  <key keycode="_121" key="F10"/>\n  <key keycode="_122" key="F11"/>\n  <key keycode="_123" key="F12"/>\n\n  <!--\n  <key keycode="_124" key="F13"/>\n  <key keycode="_124_shifted" key="Verbar"/>\n  <key keycode="_125" key="F14"/>\n  <key keycode="_126" key="F15"/>\n  <key keycode="_126_shifted" key="Tilde"/>\n  <key keycode="_127" key="F16"/>\n  <key keycode="_128" key="F17"/>\n  <key keycode="_129" key="F18"/>\n  <key keycode="_130" key="F19"/>\n  <key keycode="_131" key="F20"/>\n  <key keycode="_132" key="F21"/>\n  <key keycode="_133" key="F22"/>\n  <key keycode="_134" key="F23"/>\n  <key keycode="_135" key="F24"/>\n  -->\n\n  <key keycode="_144" platform="win" key="NumLock"/>\n  <key keycode="_145" platform="win" key="Scroll"/>\n\n  <key keycode="_188" char="U002C" key="Comma" glyph=","/>\n  <key keycode="_188_shifted" char="U003C" key="LessThan" glyph="&lt;"/>\n\n  <key keycode="_190" char="U002E" key="Period" glyph="."/>\n  <key keycode="_190_shifted" char="U003E" key="GreaterThan" glyph="&gt;"/>\n\n  <key keycode="_191" char="U002F" key="Solidus" glyph="/"/>\n  <key keycode="_191_shifted" char="U003F" key="QuestionMark" glyph="?"/>\n\n  <!-- The \'Semicolon\' character -->\n  <key keycode="_59" browser="firefox" char="U003B" key="Semicolon" glyph=";"/>\n  <key keycode="_186" char="U003B" key="Semicolon" glyph=";"/>\n\n  <!-- The \'Colon\' character -->\n  <key keycode="_59_shifted" browser="firefox" char="U003A" key="Colon" glyph=":"/>\n  <key keycode="_186_shifted" char="U003A" key="Colon" glyph=":"/>\n\n  <key keycode="_222" char="U0027" key="Apostrophe" glyph="&apos;"/>\n  <key keycode="_222_shifted" char="U0022" key="DoubleQuote" glyph="&quot;"/>\n\n  <key keycode="_219" char="U005B" key="LeftSquareBracket" glyph="["/>\n  <key keycode="_219_shifted" char="U007B" key="LeftCurlyBracket" glyph="{"/>\n\n  <key keycode="_221" char="U005D" key="RightSquareBracket" glyph="]"/>\n  <key keycode="_221_shifted" char="U007D" key="RightCurlyBracket" glyph="}"/>\n\n  <key keycode="_220" char="U005C" key="Backslash" glyph="\\"/>\n  <key keycode="_220_shifted" char="U007C" key="Pipe" glyph="|"/>\n\n  <!-- NB: Firefox cannot distinguish between meta keys, so it will always\n       report \'left\' key -->\n\n  <!-- The left meta key -->\n  <key keycode="_91" key="Meta"/>\n\n  <!-- The right meta key -->\n  <key keycode="_92" platform="win" key="Meta"/>\n\n</keyboard>\n'
);