TP.uc('~lib_src/tibet/tools/lama/TP.lama.halo/TP.lama.halo.css').setContent(
'@namespace lama url("http://www.technicalpursuit.com/2020/lama");\n@namespace pclass url("urn:tibet:pseudoclass");\n\nlama|halo {\n\n    display: block;\n    position: absolute;\n\n    /* Set an initial top, left width and height - the halo code will overwrite\n     * this values dynamically as the halo is targeted. */\n    --lama-halo-top: 200px;\n    --lama-halo-left: 200px;\n    --lama-halo-width: 100px;\n    --lama-halo-height: 100px;\n\n    --lama-halo-corner-size: 7px;\n    --lama-halo-corner-offset: -7px;\n\n    min-width: calc((var(--lama-halo-corner-size) * 3) + 3px);\n    min-height: calc((var(--lama-halo-corner-size) * 3) + 2px);\n\n    z-index: var(--tibet-HALO-TIER);\n\n    outline: dashed 1px #666;\n\n    /* Turn off pointer events so that elements *under* the halo can receive\n        events */\n    pointer-events: none;\n\n    box-shadow: 3px 3px 3px #aaa;\n}\n\nlama|halo:not([pclass|hidden]) {\n\n    top: var(--lama-halo-top);\n    left: var(--lama-halo-left);\n\n    width: var(--lama-halo-width);\n    height: var(--lama-halo-height);\n}\n\n/* In effect when the halo is focused on a target that is not a \'displayed\'\n * element (note that this is *not* the same as \'non visible\') */\nlama|halo[no-display="true"] {\n\n    background-color: #fff2aa;\n    background-image: url("data:image/svg+xml,%3Csvg width=\'6\' height=\'6\' viewBox=\'0 0 6 6\' xmlns=\'http://www.w3.org/2000/svg\'%3E%3Cg fill=\'%23000000\' fill-opacity=\'0.62\' fill-rule=\'evenodd\'%3E%3Cpath d=\'M5 0h1L0 6V5zM6 5v1H5z\'/%3E%3C/g%3E%3C/svg%3E");\n}\n\nlama|halo[no-display="true"][ancestor="head"] {\n\n    left: calc(50% - (var(--lama-halo-width) / 2));\n}\n\nlama|halo[no-display="true"][ancestor="body"] {\n\n    top: auto !important;\n    bottom: var(--lama-halo-corner-size) !important;\n\n    left: calc(50% - (var(--lama-halo-width) / 2));\n}\n\nlama|halo[mini-size="true"] {\n\n    --lama-halo-corner-size: 3.5px;\n    --lama-halo-corner-offset: -3.5px;\n}\n\nlama|halo[micro-size="true"] {\n\n    --lama-halo-corner-size: 0;\n    --lama-halo-corner-offset: 0;\n\n    background-color: red;\n    background-image: url("data:image/svg+xml,%3Csvg width=\'6\' height=\'6\' viewBox=\'0 0 6 6\' xmlns=\'http://www.w3.org/2000/svg\'%3E%3Cg fill=\'%23000000\' fill-opacity=\'0.62\' fill-rule=\'evenodd\'%3E%3Cpath d=\'M5 0h1L0 6V5zM6 5v1H5z\'/%3E%3C/g%3E%3C/svg%3E");\n}\n\nlama|halo > div.haloCorner {\n\n    position: absolute;\n\n    width: 10px;\n    height: 10px;\n}\n\nlama|halo[mini-size="true"] > div.haloCorner {\n\n    width: 5px;\n    height: 5px;\n}\n\nlama|halo[micro-size="true"] > div.haloCorner {\n\n    width: 0;\n    height: 0;\n}\n\ndiv.haloCorner {\n\n    border: solid 1px black;\n    border-radius: 0.7em;\n\n    background-color: gold;\n\n    transition: opacity 0.25s ease-out;\n\n    pointer-events: auto;\n}\n\ndiv.haloCorner:hover {\n\n    opacity: 1;\n}\n\n/* TP.NORTHWEST */\n#haloCorner-Northwest {\n\n    top: var(--lama-halo-corner-offset);\n    left: var(--lama-halo-corner-offset);\n}\n\n#haloCorner-Northwest:hover {\n\n    opacity: 1;\n\n    background-color: cornsilk;\n}\n\n/* TP.NORTH */\n#haloCorner-North {\n\n    top: var(--lama-halo-corner-offset);\n    left: calc(50% - var(--lama-halo-corner-size));\n}\n\n/* TP.NORTHEAST */\n#haloCorner-Northeast {\n\n    top: var(--lama-halo-corner-offset);\n    right: var(--lama-halo-corner-offset);\n}\n\n/* TP.WEST */\n#haloCorner-West {\n\n    left: var(--lama-halo-corner-offset);\n    top: calc(50% - var(--lama-halo-corner-size) - 1px);\n}\n\n/* TP.EAST */\n#haloCorner-East {\n\n    right: var(--lama-halo-corner-offset);\n    top: calc(50% - var(--lama-halo-corner-size) - 1px);\n}\n\n/* TP.SOUTHWEST */\n#haloCorner-Southwest {\n\n    bottom: var(--lama-halo-corner-offset);\n    left: var(--lama-halo-corner-offset);\n}\n\n#haloCorner-Southwest:hover {\n\n    opacity: 1;\n\n    background-color: cornsilk;\n}\n\n/* TP.SOUTH */\n#haloCorner-South {\n\n    left: calc(50% - var(--lama-halo-corner-size));\n    bottom: var(--lama-halo-corner-offset);\n}\n\n/* TP.SOUTHEAST */\n#haloCorner-Southeast {\n\n    bottom: var(--lama-halo-corner-offset);\n    right: var(--lama-halo-corner-offset);\n}\n\n#haloCorner-Southeast:hover {\n\n    opacity: 1;\n\n    background-color: cornsilk;\n}\n\n/* Halo breadcrumb */\nlama|halo > lama|breadcrumb {\n\n    top: -18px;\n\n    /* Turn pointer events back on for the breadcrumb */\n    pointer-events: auto;\n}\n\ndiv[busyfor="LamaHalo"] {\n\n    z-index: var(--tibet-HUD-TIER);\n}\n'
);